<?php
/**
* @version 1.0
* @package ContentBuilder Link
* @copyright (C) 2012 by Markus Bopp
* @license Released under the terms of the GNU General Public License
**/

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

jimport( 'joomla.plugin.plugin' );

class plgContentContentbuilder_link extends JPlugin {

    function __construct( &$subject, $params )
    {
        parent::__construct($subject, $params);
    }
    
    /**
     * Joomla 1.5 compatibility
     */
    function onPrepareContent(&$article, &$params, $limitstart = 0, $is_list = false, $form = null, $item = null )
    {
        $this->onContentPrepare('', $article, $params, $limitstart, $is_list, $form, $item);
    }

    function onContentPrepare($context, &$article, &$params, $limitstart = 0, $is_list = false, $form = null, $item = null) {
        
        $protect = false;
        
        $plugin = JPluginHelper::getPlugin('content', 'contentbuilder_link');
        jimport( 'joomla.html.parameter' );
	$pluginParams = new JParameter($plugin->params);
        
        jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');
        
        if(!JFile::exists(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder.php'))
        {
            return true;
        }
        
        require_once(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder.php');
        
        /*
         * As of Joomla! 1.6 there is just the text passed if the article data is not passed in article context.
         * (for instance with categories).
         * But we need the article id, so we use the article id flag from content generation.
         */
        if(is_object($article) && !isset($article->id) && !isset($article->cbrecord) && isset($article->text) && $article->text){
            preg_match_all("/<!--\(cbArticleId:(\d{1,})\)-->/si", $article->text, $matched_id);
            if(isset($matched_id[1]) && isset($matched_id[1][0])){
                $article->id = intval($matched_id[1][0]);
            }   
        }
        
        // if this content plugin has been called from within list context
        if($is_list){
            
            if(!trim($article->text)){
                return true;
            }
            
            $article->cbrecord = $form;
            $article->cbrecord->items = array();
            $article->cbrecord->items[0] = $item;
            $article->cbrecord->record_id = $item->colRecord;
        }
        
        if(!JFolder::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder')) {
            JFolder::create(JPATH_SITE . DS . 'media' . DS . 'contentbuilder');
        }
        
        if(!JFile::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'index.html')) JFile::write(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'index.html', $def = '');
        
        if(!JFolder::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins')) {
            JFolder::create(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins');
        }
        
        if(!JFile::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'index.html')) JFile::write(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'index.html', $def = '');
        
        if(isset($article->id) || isset($article->cbrecord)){
            
            $db = JFactory::getDBO();
            
            $matches = array();
            
            preg_match_all("/([\{]CBLink(.*)[\}])(.*)([\{][\/]CBLink[\}])/isU", $article->text, $matches);
            
            if(isset($matches[0]) && is_array($matches[0]) && isset($matches[1]) && is_array($matches[1])){
                
                $form_id = 0;
                $record_id = 0;
                
                $frontend = true;
                if (JFactory::getApplication()->isAdmin()) {
                    $frontend = false;
                }
                
                $title = '';
                $url = '';
                
                if (isset($article->id) && $article->id && !isset($article->cbrecord)) {

                    // try to obtain the record id if if this is just an article
                    $db->setQuery("Select form.rating_slots,form.`title_field`,form.`protect_upload_directory`,form.`reference_id`,article.`record_id`,article.`form_id`,form.`type`,form.`published_only`,form.`own_only`,form.`own_only_fe` From #__contentbuilder_articles As article, #__contentbuilder_forms As form Where form.`published` = 1 And form.id = article.`form_id` And article.`article_id` = " . $article->id);
                    $data = $db->loadAssoc();

                    require_once(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder.php');
                    $form = contentbuilder::getForm($data['type'], $data['reference_id']);
                    if(!$form || !$form->exists){
                        return true;
                    }
                    
                    if ($form) {
                        
                        $form_id = $data['form_id'];
                        $record_id = $data['record_id'];
                        
                        jimport('joomla.application.component.helper');
                        $db->setQuery('Select title, catid from #__content Where id = ' . intval($article->id));
                        $ass = $db->loadAssoc();
                        $article->catid = $ass['catid'];
                        $title = cbinternal($ass['title']);
                        $url = JRoute::_(ContentHelperRoute::getArticleRoute($article->id.(isset($article->alias) ? ':'.$article->alias : ''), (isset($article->catid) ? (int)$article->catid : 0)));
                    }
                    
                } else if (isset($article->cbrecord) && isset($article->cbrecord->id) && $article->cbrecord->id) {
                    $form = $article->cbrecord->form;
                    $form_id = $article->cbrecord->id;
                    $record_id = $article->cbrecord->record_id;
                    $title = '';
                    foreach($article->cbrecord->items As $item){
                        if( $item->recElementId == $article->cbrecord->title_field ){
                            $title = cbinternal($item->recValue);
                            if($title){
                                $title = JFactory::getDocument()->getTitle() . ($is_list ? ': ' . $title : '' );
                            }
                            break;
                        }
                    }
                    $url = JRoute::_('index.php?option=com_contentbuilder&controller=details&title='.contentbuilder::stringURLUnicodeSlug($title).'&id='.$form_id.'&record_id='.$record_id.(JRequest::getInt('Itemid', 0) != 0 ? '&Itemid=' . JRequest::getInt('Itemid', 0) : '').(JRequest::getCmd('lang','') != '' ? '&lang=' . JRequest::getCmd('lang','') : ''));
                }
                
                if(!is_object($form)){
                    return true;
                }
                
                $view_allowed = true;
                
                if(!$is_list){
                    
                    contentbuilder::setPermissions($form_id, $record_id, $frontend ? '_fe' : '');
                    
                    if($frontend){
                        if(!contentbuilder::authorizeFe('view')){
                           $view_allowed = false;
                        }
                    }else{
                        if(!contentbuilder::authorize('view')){
                           $view_allowed = false;
                        }
                    }
                }

                $i = 0;
                foreach($matches[2] As $match){
                    
                    $_url = $url;
                    
                    $target = '';
                    $modal_width = 600;
                    $modal_height = 400;
                    $use_page_title = false;
                    
                    $options = explode(';', trim($match));
                    foreach($options As $option){
                        $keyval = explode(':',trim($option), 2);
                        if(count($keyval) == 2){
                            $value = trim($keyval[1]);
                            switch(strtolower(trim($keyval[0]))){
                                case 'target':
                                    if($value == 'modal'){
                                        JHtml::_('behavior.modal');
                                        $_url .= (strpos($_url, '?') === false ? '?' : '&amp;') . 'tmpl=component';
                                    }
                                    $target = $value;
                                    break;
                                case 'modal-width':
                                    $modal_width = $value;
                                    break;
                                case 'modal-height':
                                    $modal_height = $value;
                                    break;
                                case 'use-title':
                                    $use_page_title = $value == 'true' ? true : false;
                                    break;
                                default:
                            }
                        }
                    }
                  
                    $article->text = str_replace($matches[1][$i], '<a href="'.$_url.'"'.($use_page_title ? ' title="'.htmlentities($title, ENT_QUOTES, 'UTF-8').'"' : '').($target && $target == 'modal' ? ' class="modal" rel="{handler: \'iframe\', size: {x: '.$modal_width.', y: '.$modal_height.'}}"' : '').($target && $target != 'modal' ? ' target="'.$target.'"' : '').'>', $article->text);
                    $article->text = str_replace($matches[4][$i], '</a>', $article->text);
                    
                    $i++;
                }
            }
        }

	return true;
    }
}